<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2005 Gernot Ploiner
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Simple Javascript Fotogallery' for the 'mbit_gallery' extension.
 *
 * @author	Gernot Ploiner
 */


//require_once(PATH_tslib.'class.tslib_pibase.php');

class tx_mbitgallery_pi1 extends tslib_pibase {
	var $prefixId = 'tx_mbitgallery_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_mbitgallery_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'mbit_gallery';	// The extension key.
	//var $pi_checkCHash = TRUE;
	
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		
		$i = $a = 0;
		$output = "";
		$error = false;
		$gallerypath = trim($this->conf['gallerypath']); // Path to the Gallery
		$piccount = trim($this->conf['piccount']); // show amount of Pics of each Gallery
		$gallerycount = trim($this->conf['gallerycount']); // show amount of all Pics in the Gallery
		$yearsplit = trim($this->conf['yearsplit']); // Split the List in Year Blocks
		$openpid = trim($this->conf['openpid']); // PID of Site for Show
		$open = trim($this->conf['open']); // Target for Show
		$templatefile = trim($this->conf['templatefile']); // Path to the Template
		$popupwidth = trim($this->conf['popupwidth']); // width of the Popup
		$popupheight = trim($this->conf['popupheight']); // height of the Popup
		$popupresize = trim($this->conf['popupresize']); // resize the Popup
		$popupscrollbar = trim($this->conf['popupscrollbar']); // scrollbars in the Template

		if (array_key_exists("unter", $this->piVars)) {
			$folder = dir($gallerypath . "/" . $this->piVars["unter"]);
			$zeichenkette = ereg_replace('_', ' ', $this->piVars["unter"]);
			$header = substr ($zeichenkette,8);
			while ($file=$folder->read()) {	
				if (substr("$file",-3) == "jpg" || substr("$file",-3) == "JPG" || substr("$file",-4) == "JPEG" || substr("$file",-4) == "jpeg" || substr("$file",-3) == "gif" || substr("$file",-3) == "GIF" || substr("$file",-3) == "png" || substr("$file",-3) == "PNG") {
					$bild[$i]=$file;
					$i++;
				}
			}
			if ($i > 0) {
				sort ($bild);
				$extraJS = "wo = 0;\nbild = Array();\nsizew = Array();\nsizeh = Array();\n";
	
				for($i=0;$bild[$i];$i++) {	
					$extraJS.= "bild[$i]='$bild[$i]';\n";
				}
				for($i=0;$bild[$i];$i++) {
					$arr = GetImageSize($gallerypath . "/" . $this->piVars["unter"] . "/" . $bild[$i]);
					$extraJS.= "sizew[$i]='" . $arr[0] . "';\n";
					$extraJS.= "sizeh[$i]='" . $arr[1] . "';\n";
				}
				$extraJS.= "function mbit_wo() {
					if (wo <= 0) {
						prev = 0;
					} else {
						prev = -1;
					}
					if (wo >= ";
				$extraJS.= $i-1;
				$extraJS.= ") {
						next = 0;
					} else {
						next = 1;
					}
				}
				function mbit_changepic(to) {
					document.getElementById('pic').src = '" . $gallerypath . $this->piVars["unter"] . "/' + bild[wo+to];
					wo = wo + to;
					mbit_wo();
					document.getElementById(\"wobin\").childNodes[0].nodeValue = wo+1;
					// document.getElementById('wobin').innerText = wo+1;
				}
				function mbit_reszie() {
					document.getElementById('pic').width = sizew[wo];
					document.getElementById('pic').height = sizeh[wo];
				}
				mbit_wo();";
			} else {
				$output = "Folder '" . $gallerypath . "/" . $this->piVars["unter"] . "' is empty.";
				$error = true;
			}

			$this->templateCode = $this->cObj->fileResource($templatefile);
			$meintemplate = $this->templateCode;
			$markerArray = array();
			$markerArray['###PICTOTAL###'] = "<span class='tx_mbitgallery_total'>" . htmlspecialchars($this->pi_getLL('pic')) . " <span id=\"wobin\">1</span> " . htmlspecialchars($this->pi_getLL('of')) . " " . $i . "</span>";
			$markerArray['###HEADLINE###'] = "<span class='tx_mbitgallery_header'>" . $header . "</span>";
			$markerArray['###PIC###'] = "<img class='tx_mbitgallery_pic' src=\"" . $gallerypath . $this->piVars["unter"] . "/" . $bild[0] . "\" border=\"0\" id=\"pic\" onload=\"mbit_reszie();\">";
			$markerArray['###NEXT###'] = "<a class='tx_mbitgallery_prev' href=\"javascript:\" onClick=\"mbit_changepic(next,'" . $this->piVars["unter"] . "/" . $bild[0] . "/');return false\">" . $this->pi_getLL('next') . "</a>";
			$markerArray['###PREV###'] = "<a class='tx_mbitgallery_next' href=\"javascript:\" onClick=\"mbit_changepic(prev,'" . $this->piVars["unter"] . "/" . $bild[0] . "/');return false\">" . $this->pi_getLL('prev') . "</a>";
			$output.= $this->cObj->substituteMarkerArrayCached($meintemplate, $markerArray, array(), array());
		} else {
			if ($folder = @dir($gallerypath)) {
				while($file=$folder->read()) {
					if ($file != "." && $file != ".." && substr($file,-4) != "JPEG" && substr($file,-4) != ".xml" && substr($file,-4) != ".swf" && substr($file,-5) != ".html") {
//					if ($file != "." && $file != ".." && is_dir($file)) {
						$folder2 = dir($gallerypath . "/" . $file);
						$filess = -2;
						while($file2 = $folder2->read()) {
							if (substr($file2,-4) != ".xml") {
								$filess++;
							}
						}
						$allfiles += $filess;
						$zeichenkette = ereg_replace('_', ' ', $file);
						$tok = substr ($zeichenkette,8);
						$toknow[$i] = substr ($zeichenkette,0,4);
						$i++;
						$out[$i] = $this->pi_linkToPage($tok, $openpid, $open, array($this->prefixId.'[unter]' => $file));
						if ($open == "mbitgallery_popup") {
							$out[$i] = $this->pi_openAtagHrefInJSwindow(html_entity_decode($out[$i]), popup, "width=" . $popupwidth . ",height=" . $popupheight . ",status=yes,resizable=" . $popupresize . ",dependent=yes,scrollbars=" . $popupscrollbar . "");
						}
						if ($piccount == 1) {
							$out[$i].= " (" . $filess . ")";
						}
						$out[$i].= "<br />";
					}
				}
				$folder->close();
	
				if (count($out) != 0) {
					sort($out);
					sort($toknow);
					$a=$i;
					while($a>=0) {
						if (!isset($last) && $yearsplit == 1) {
							$output.= "<span class='tx_mbitgallery_year'>" . $toknow[$a] . "</span><br />"; $last = $toknow[$a];
						}
						if ($toknow[$a] != $last && $yearsplit == 1) {
							$output.= "<br /><br /><span class='tx_mbitgallery_year'>" . $toknow[$a] . "</span><br />";
						}
						$output.= $out[$a];
						$last = $toknow[$a];
						$a--;
					}
					if ($gallerycount == 1) {
						$output.= "<span class='tx_mbitgallery_count'>" . htmlspecialchars($this->pi_getLL('total')) . $allfiles . htmlspecialchars($this->pi_getLL('pics')) . "</span><br />";
					}
				} else { // Folder is empty
					$output.= "Folder '" . $gallerypath . "' is empty.";
					$error = true;
				}
			} else { // Folder does not exist
				$output.= "Folder '" . $gallerypath . "' does not exist.";
				$error = true;
			}
		}

		$GLOBALS['TSFE']->setJS('myext_js', $extraJS);
		if ($error == true) {
			return "<div style='border: 3px solid red; padding: 3px;'>" . $this->pi_wrapInBaseClass($output) . "</div>";
		} else {
			return $this->pi_wrapInBaseClass($output);
		}
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mbit_gallery/pi1/class.tx_mbitgallery_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mbit_gallery/pi1/class.tx_mbitgallery_pi1.php']);
}
?>
